unit formaleSprache;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Printers, Info, HilfeRegeln, ExtCtrls;

type
  TRegel=Record NonTerminal:String[8];Terminal:String[20] end;
  TStackInhalt=Array[1..2]of Word; // RegelNr, Einfgestelle
  TStack= ^TStackEintrag;
  TStackEintrag=record
                Eintrag:TStackInhalt;
                Naechster:TStack
               end;
  TformSp = class(TForm)
    Menu: TMainMenu;
    Datei: TMenuItem;
    Laden: TMenuItem;
    Speichern: TMenuItem;
    Drucken: TMenuItem;
    Beenden: TMenuItem;
    DateiLesen: TOpenDialog;
    DateiSpeichern: TSaveDialog;
    PrintDialog: TPrintDialog;
    RegelAnzeige: TMemo;
    LabelRegeln: TLabel;
    Start: TMenuItem;
    Hilfe: TMenuItem;
    Info: TMenuItem;
    Hinweise: TMenuItem;
    RegelListe: TListBox;
    Label1: TLabel;
    LabelWort: TLabel;
    Ausgabe: TMemo;
    Panel1: TPanel;
    N1: TMenuItem;
    N2: TMenuItem;
    Herleiten: TMenuItem;
    N3: TMenuItem;
    Herleitungdrucken: TMenuItem;
    LabelNon: TLabel;
    NonTAnzahl: TEdit;
    LabelT: TLabel;
    TAnzahl: TEdit;
    RegelL: TMemo;
    LabelR: TLabel;
    Nummern: TListBox;
    procedure LadenClick(Sender: TObject);
    procedure SpeichernClick(Sender: TObject);
    procedure BeendenClick(Sender: TObject);
    procedure DruckenClick(Sender: TObject);
    procedure RegelListeClick(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure HinweiseClick(Sender: TObject);
    procedure HerleitenClick(Sender: TObject);
    procedure HerleitungdruckenClick(Sender: TObject);
    procedure RegelListeKeyDown(Sender: TObject; var Key: Word;
                                Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
   Regeln:Array of TRegel;
   N:Word;
   Keller:TStack;
   Wort:String;
  public
    { Public-Deklarationen }
  end;

var formSp: TformSp;

implementation

{$R *.DFM}
{$R+,Q+}
const Leer='';Bereich=128;Alle=255;MaxRnd=13;

 function StackLeer(Stapel:TStack):boolean;
  begin StackLeer:=Stapel=nil end;

 procedure InitStack(var Stapel:TStack);
  begin Stapel:=nil end;

 procedure Push(var Stapel:TStack;StapelInhalt:TStackInhalt);
  // Daten auf den Stapel legen
  var NeuerStapel:TStack;
   begin
    new(NeuerStapel);NeuerStapel^.Eintrag:=StapelInhalt;
    NeuerStapel^.Naechster:=Stapel;Stapel:=NeuerStapel;
   end;

 procedure Pop(var Stapel:TStack;var StapelInhalt:TStackInhalt);
  // Daten vom Stapel nehmen
  var AktuellerStapel:TStack;
   begin
    StapelInhalt:=Stapel^.Eintrag;
    AktuellerStapel:=Stapel^.Naechster;
    Dispose(Stapel);Stapel:=AktuellerStapel;
   end;

 procedure Ersetze(Variable,Muster:String;var Stelle:Word;var Wort:String);
  begin
   Stelle:=pos(Variable,Wort);
   if Stelle>0 then
    begin
     Delete(Wort,Stelle,Length(Variable));
     if Muster<>Leer then Insert(Muster,Wort,Stelle)
    end
  end;
 procedure Zurueck(Variable,Muster:String;Stelle:Word;var Wort:String);
  begin
   Delete(Wort,Stelle,Length(Variable));
   Insert(Muster,Wort,Stelle)
  end;
 procedure CopyRight(var Name:String);
  var I:Word; Code:String;
  begin
   RandSeed:=MaxRnd;Code:='zы';Name:='';
   for I:=1 to Length(Code) do
    Name:=Name+char((ord(Code[I])-random(Bereich)) and Alle);
  end;

 procedure TformSp.LadenClick(Sender: TObject);
  var DateiName:String;
      LF:File of TRegel;
      I:Word;
  begin
   with DateiLesen do
    begin
     Filter:='Grammatik Files (*.fsp)|*.fsp';
     DefaultExt:='fsp';
     if Execute then                // Dateidialog ffnen
      begin
       DateiName:=ExtractFilename(FileName);
       AssignFile(LF,FileName);  // im Dialogfeld ausgewhlte Datei
       {$I-} reset(LF) {$I+};
       if IoResult<>0 then
        begin
         MessageDlg('Die Datei '+DateiName+' existiert nicht!',mtError,[mbOk],0);
         exit
        end
       else
        begin
         N:=0;
         while not EoF(LF) do
          begin
           Inc(N);SetLength(Regeln,N+1);
           Read(LF,Regeln[N])
          end
        end;
       CloseFile(LF);
       RegelListe.Clear;
       RegelAnzeige.Clear;
       Nummern.Clear;
       Ausgabe.Clear;
       RegelL.Clear;
       NonTAnzahl.Text:='';
       TAnzahl.Text:='';
       for i:=1 to N do
        RegelAnzeige.Lines.Add(Regeln[I].NonTerminal+' ---> '+Regeln[I].Terminal);
       LabelRegeln.Caption:='Deine Regeldatei  -  '+DateiName;
      end;
    end;
  end;

 procedure TformSp.SpeichernClick(Sender: TObject);
  var DateiName,FName:String;
      LF:File of TRegel;
      I,K,Anzahl,AN:Word;
      Zeile,Links,Rechts:String;
  begin
   if RegelAnzeige.Lines.Count=0 then
    begin
     MessageDlg('Es gibt NICHTS zu speichern!!',mtError,[mbOk],0);
     exit;
    end;
   Anzahl:=RegelAnzeige.Lines.Count;
   AN:=0;
   for K:=0 to Anzahl-1 do // RegelAnzeige ---> Regeln
    begin
     Zeile:=RegelAnzeige.Lines[K];
     Links:=Copy(Zeile,1,pos('-',Zeile)-1);
     Rechts:=Copy(Zeile,pos('>',Zeile)+1,Length(Zeile)-pos('>',Zeile));
     while pos(' ',Links)>0 do Delete(Links,pos(' ',Links),1);
     while pos(' ',Rechts)>0 do Delete(Rechts,pos(' ',Rechts),1);
     if Links<>'' then
      begin
       inc(AN);SetLength(Regeln,AN+1);
       Regeln[AN].NonTerminal:=Links;Regeln[AN].Terminal:=Rechts;
      end
    end;
   with DateiSpeichern do
    begin
     Filter:='Grammatik Files (*.fsp)|*.fsp';
     DefaultExt:='fsp';
     Options:=[ofOverwritePrompt]; // Sicherheitsabfrage wegen berschreibens
     if Execute then                { Dateidialog speichern }
      begin
       DateiName:=ExtractFilename(FileName);
       FName:=FileName;
       if pos('.',FName)>0 then
        FName:=Copy(FName,1,pos('.',FName)-1);
       FileName:=FName+'.fsp';
       AssignFile(LF,FileName);  { im Dialogfeld ausgewhlte Datei }
       {$I-} Rewrite(LF) {$I+};
       if IoResult<>0 then
        begin
         MessageDlg('Die Datei '+DateiName+' kann nicht gespeichert werden!',mtError,[mbOk],0);
         exit
        end
       else for I:=1 to AN do Write(LF,Regeln[I]);
       CloseFile(LF);
      end;
    end;
  end;

 procedure TformSp.BeendenClick(Sender: TObject);
  begin close end;

 procedure TformSp.DruckenClick(Sender: TObject);
  const maxzeilen  = 60;
        texthoehe  = 40;   // 4 mm
        linkerRand = 200;  // 20 mm
        obererRand = 100;  // 10 mm
  var CopyNum,NumCopies,K,y: Integer;
      w,v : TSize;
      OUTDC : HDC;
  begin
   if RegelAnzeige.Lines.Count=0 then
    begin
     MessageDlg('Es gibt NICHTS zu drucken!!',mtError,[mbOk],0);
     exit;
    end;
    if PrintDialog.Execute then
     begin
      NumCopies:=PrintDialog.Copies;
      Printer.BeginDoc;
      OutDC:=Printer.Canvas.Handle;
      SetMapMode(OutDC,mm_Lometric);     // 1/10 mm aber Y geht nach oben
      GetWindowExtEx(OutDC,w);           // Auflsung ermitteln
      GetViewportExtEx(OutDC,v);
      SetMapMode(OutDC,MM_ANISOTROPIC);         // neuer Abb.-Modus
      SetWindowExtEX(OutDC,w.cx,w.cy,nil);      // Skalierung ...
      SetViewPortExtEx(OutDC,v.cx,-v.cy,nil);
      Printer.Canvas.Font.Name:='Courier New';
      Printer.Canvas.Brush.Color:=clwhite;   // Hintergrundfarbe
      Printer.Canvas.Font.Height:=Texthoehe;
      for CopyNum:=1 to NumCopies do
       begin
        Printer.Canvas.Font.Style:=[fsbold];
        Printer.Canvas.Textout(linkerRand,obererRand,LabelRegeln.Caption);
        Printer.Canvas.Font.Style:=[];
        for K:=0 to RegelAnzeige.Lines.Count-1 do
         begin
          y:=obererRand+(K+2)*(texthoehe+3);
          Printer.Canvas.TextOut(linkerRand,y,RegelAnzeige.Lines[K]);
         end
       end;
      Printer.EndDoc;
     end
  end;

 procedure TformSp.HerleitenClick(Sender: TObject);
   var Zeile,Links,Rechts,Meister:String;
      AN,K,Anzahl:Word;
  begin
   CopyRight(Meister);
   Caption:='formale Sprachen   by Meister '+Meister;
   N:=RegelAnzeige.Lines.Count;
   if N=0 then
    begin
     MessageDlg('Es gibt NICHTS zu bearbeiten!!',mtError,[mbOk],0);
     exit;
    end;
   Nummern.Clear;
   Anzahl:=RegelAnzeige.Lines.Count;
   AN:=0;
   for K:=0 to Anzahl-1 do // RegelAnzeige ---> Regeln
    begin
     Zeile:=RegelAnzeige.Lines[K];
     Links:=Copy(Zeile,1,pos('-',Zeile)-1);
     Rechts:=Copy(Zeile,pos('>',Zeile)+1,Length(Zeile)-pos('>',Zeile));
     while pos(' ',Links)>0 do Delete(Links,pos(' ',Links),1);
     while pos(' ',Rechts)>0 do Delete(Rechts,pos(' ',Rechts),1);
     if Links<>'' then
      begin
       inc(AN);SetLength(Regeln,AN+1);
       Nummern.Items.Add(Format('%4s',[IntToStr(AN)]));
       Regeln[AN].NonTerminal:=Links;Regeln[AN].Terminal:=Rechts;
      end
    end;
   RegelListe.Clear;
   for K:=1 to AN do
    if Length(Regeln[K].NonTerminal+Regeln[K].Terminal)>0 then
     RegelListe.Items.ADD(Regeln[K].NonTerminal+' -> '+Regeln[K].Terminal);
   RegelListe.Items.ADD('');
   RegelListe.Items.ADD('rckgngig');
   InitStack(Keller);Wort:='S';
   Ausgabe.Clear;Ausgabe.Lines.Add(Wort);
   RegelL.Clear;NonTAnzahl.Text:='1';TAnzahl.Text:='';
  end;

 procedure TformSp.RegelListeClick(Sender: TObject);
  const Alfa='QWERTZUIOPASDFGHJKLYXCVBNM';
  var wo,K,Nr,NON,T:Word;
      BR:TStackInhalt;
      Stelle:Word;
      Zeile,RegelZeile:String;
  begin
   Nr:=RegelListe.ItemIndex+1;
   if (NR=N+2) and (not StackLeer(Keller)) then
    begin
     Pop(Keller,BR);
     Zurueck(Regeln[BR[1]].Terminal,Regeln[BR[1]].NonTerminal,BR[2],Wort);
     Ausgabe.Lines.Delete(Ausgabe.Lines.Count-1);
     Zeile:=Ausgabe.Lines[Ausgabe.Lines.Count-1];NON:=0;
     Zeile:=Copy(Zeile,1,pos(' ',Zeile)-1);
     for k:=1 to Length(Zeile) do
      if pos(Zeile[k],ALFA)>0 then inc(NON);
     T:=Length(Zeile)-NON;
     NONTAnzahl.Text:=IntToStr(NON);TAnzahl.Text:=IntToStr(T);
     for K:=0 to Ausgabe.Lines.Count-1 do
      begin
       Zeile:=Ausgabe.Lines[K];wo:=pos(' ',Zeile);
       RegelZeile:=RegelZeile+Copy(Zeile,wo+1,Length(Zeile)-wo);
      end;
     RegelL.Clear;
     RegelL.Lines.Add(RegelZeile);
    end;
   if NR<=N then
    begin
     Ersetze(Regeln[NR].NonTerminal,Regeln[NR].Terminal,Stelle,Wort);
     if Stelle>0 then
      begin
       Ausgabe.Lines.Add(Wort+'  '+IntToStr(Nr));
       Zeile:=Ausgabe.Lines[Ausgabe.Lines.Count-1];NON:=0;
       Zeile:=Copy(Zeile,1,pos(' ',Zeile)-1);
       for k:=1 to Length(Zeile) do
        if pos(Zeile[k],ALFA)>0 then inc(NON);
       T:=Length(Zeile)-NON;
       NONTAnzahl.Text:=IntToStr(NON);TAnzahl.Text:=IntToStr(T);
       BR[1]:=NR;BR[2]:=Stelle;Push(Keller,BR);
       for K:=0 to Ausgabe.Lines.Count-1 do
        begin
         Zeile:=Ausgabe.Lines[K];wo:=pos(' ',Zeile);
         RegelZeile:=RegelZeile+Copy(Zeile,wo+1,Length(Zeile)-wo);
        end;
       RegelL.Clear;
       RegelL.Lines.Add(RegelZeile);
      end
     else MessageDlg('Es gibt NICHTS zu ersetzen!!',mtError,[mbOk],0);
    end
  end;

 procedure TformSp.InfoClick(Sender: TObject);
  begin InfoBox.ShowModal end;

 procedure TformSp.HinweiseClick(Sender: TObject);
  begin RegelnBox.ShowModal end;

 procedure TformSp.HerleitungdruckenClick(Sender: TObject);
  const maxzeilen  = 60;
        texthoehe  = 40;   // 4 mm
        linkerRand = 200;  // 20 mm
        obererRand = 100;  // 10 mm
  var CopyNum,NumCopies,K,y,ZeilenNr: Integer;
      w,v : TSize;
      OUTDC : HDC;
  begin
   if Ausgabe.Lines.Count=0 then
    begin
     MessageDlg('Es gibt keine Herleitung zu drucken!',mtError,[mbOk],0);
     exit;
    end;
   if PrintDialog.Execute then
    begin
     NumCopies:=PrintDialog.Copies;
     Printer.BeginDoc;
     OutDC:=Printer.Canvas.handle;
     SetMapMode(OutDC,mm_lometric);     // 1/10 mm aber Y geht nach oben
     GetWindowExtEx(OutDC,w);           // Auflsung ermitteln
     GetViewportExtEx(OutDC,v);
     SetMapMode(OutDC,MM_ANISOTROPIC);         // neuer Abb.-Modus
     SetWindowExtEX(OutDC,w.cx,w.cy,nil);      // Skalierung ...
     SetViewPortExtEx(OutDC,v.cx,-v.cy,nil);
     Printer.Canvas.Font.Name:='Courier New';
     Printer.Canvas.Brush.Color:=clwhite;   // Hintergrundfarbe
     Printer.Canvas.Font.Height:=Texthoehe;
     for CopyNum:=1 to NumCopies do
      begin
       Printer.Canvas.Font.Style:=[fsbold];
       Printer.Canvas.Textout(linkerRand,obererRand,
                     'Herleitung'+' / Seite: '+inttostr(Printer.pagenumber));
       Printer.Canvas.Font.Style:=[];
       ZeilenNr:=0;
       for K:=0 to Ausgabe.Lines.Count-1 do
        begin
         y:=obererRand+(ZeilenNr+2)*(texthoehe+3);
         Printer.Canvas.TextOut(linkerRand,y,Ausgabe.Lines[K]);
         Inc(ZeilenNr);
         if ZeilenNr=maxzeilen then
          begin
           Printer.newpage;
           Printer.Canvas.Font.Style:=[fsbold];
           Printer.Canvas.Textout(linkerRand,obererRand,
                         'Herleitung'+' / Seite: '+inttostr(Printer.pagenumber));
           Printer.Canvas.Font.Style:=[];
           ZeilenNr:=0;
          end
        end
      end;
     Printer.EndDoc;
    end
   end;

 procedure TformSp.RegelListeKeyDown(Sender: TObject; var Key: Word;
                                     Shift: TShiftState);
  begin
   if Key=13 then RegelListeClick(Sender);
  end;

 procedure TformSp.FormCreate(Sender: TObject);
  begin
   SetLength(Regeln,1);
  end;

end.

